package com.pixelai.api.base.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.base.entity.AcConfig;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author mzl
 * @since 2020-07-09
 */
public interface AcConfigService extends IService<AcConfig> {

    /**
     * 条件查询
     *
     * @param example
     * @return
     */
    List<AcConfig> list(AcConfig example);

    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    IPage<AcConfig> page(AcConfig example, IPage page);

    /**
     * 设置配置状态
     *
     * @param id
     * @param configvalue
     */
    @Transactional
    AcConfig setConfigvalue(Integer id, String configvalue);

    /**
     * 获取注册状态
     *
     * @return
     */
    String getRegisterStatus();

    /**
     * 根据名称获取值
     *
     * @param configname
     * @return
     */
    AcConfig findByConfigname(String configname);

    /**
     * 初始化期次考生编号
     *
     * @param configname
     * @param configvalue
     * @return
     */
    @Transactional
    AcConfig initEnrollNum(String configname, String configvalue);

    /**
     * 获取期次考试的人数
     *
     * @param enrollid
     * @return
     */
    Integer findNumByEnrollid(String enrollid);

}
