package com.pixelai.api.chat.controller;

import com.base.annotation.SysLog;
import com.base.helper.Result;
import com.pixelai.api.chat.service.VolcengineChatService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@Api(tags = "火山方舟api调用")
@RestController
@RequestMapping("/VolcengineChat")
public class VolcengineChatController {
    @Autowired
    private VolcengineChatService volcengineChatService;

    @SysLog(action = "VolcengineChat:generatePromptWords", value = "火山方舟在线推理:提示词生成")
    @ApiOperation(value = "提示词生成", notes = "火山方舟在线推理")
    @RequestMapping(value = "generatePromptWords", method = {RequestMethod.POST})
    public Result<Object> generatePromptWords(@RequestParam("message") String message) throws Exception {
        Map response = volcengineChatService.generatePromptWords(message);
        Object data = response.get("body");
        return new Result<>(true, data);
    }
}
