package com.pixelai.api.component.dao;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.component.entity.CpPhoto;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.pixelai.api.component.vo.CpPhotoVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author gjj
 * @since 2024-10-26
 */
public interface CpPhotoMapper extends BaseMapper<CpPhoto> {
    /**
     * 条件查询
     *
     * @param page
     * @param queryWrapper
     * @return
     */
    List<CpPhotoVo> findByExample(@Param(Constants.WRAPPER) QueryWrapper<CpPhotoVo> queryWrapper, Page page);

    /**
     * 根据id查询照片
     *
     * @param id
     * @return
     */
    CpPhotoVo findPhotoById(@Param("id") Integer id);
}
