package com.pixelai.api.component.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.component.entity.CpLabel;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.component.vo.CpLabelTree;
import com.pixelai.api.component.vo.CpLabelVo;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author gjj
 * @since 2024-10-26
 */
public interface CpLabelService extends IService<CpLabel> {
    public List<CpLabelTree> getChildrenList(CpLabelTree tree, List<CpLabelTree> list);
    /**
     * 根据id查询
     * @param id
     * @return
     */
    CpLabelVo getLabelById(Integer id);

    /**
     * 条件查询
     * @param example
     * @return
     */
    List<CpLabel> list(CpLabel example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    IPage<CpLabel> page(CpLabel example,IPage page);

    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    Page<CpLabelVo> findByPage(CpLabelVo example, Page page);

}
