package com.pixelai.api.component.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.component.entity.CpPhoto;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.component.vo.CpPhotoVo;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author gjj
 * @since 2024-10-26
 */
public interface CpPhotoService extends IService<CpPhoto> {
    /**
     * 保存照片
     * @param cpPhotoVo
     * @return
     */
    CpPhotoVo savePhoto(CpPhotoVo cpPhotoVo);

    /**
     * 修改照片
     * @param cpPhotoVo
     * @return
     */
    CpPhotoVo updatePhoto(CpPhotoVo cpPhotoVo);

    /**
     * 根据id删除
     * @param id
     * @return
     */
    Boolean deletePhotoById(Integer id);

    /**
     * 条件查询
     * @param example
     * @return
     */
    List<CpPhoto> list(CpPhoto example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    IPage<CpPhoto> page(CpPhoto example,IPage page);
    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    Page<CpPhotoVo> findByPage(CpPhotoVo example, Page page);

}
