package com.pixelai.api.component.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.component.entity.CpVideo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.component.vo.CpVideoVo;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author gjj
 * @since 2024-11-12
 */
public interface CpVideoService extends IService<CpVideo> {

    /**
     * 保存视频
     * @param cpVideoVo
     * @return
     */
    CpVideoVo saveVideo(CpVideoVo cpVideoVo);

    /**
     * 修改视频
     * @param cpVideoVo
     * @return
     */
    CpVideoVo updateVideo(CpVideoVo cpVideoVo);

    /**
     * 根据id删除
     * @param id
     * @return
     */
    Boolean deleteVideoById(Integer id);
    /**
     * 条件查询
     * @param example
     * @return
     */
    List<CpVideo> list(CpVideo example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    IPage<CpVideo> page(CpVideo example,IPage page);
    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    Page<CpVideoVo> findByPage(CpVideoVo example, Page page);

}
