package com.pixelai.api.component.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.pixelai.api.component.entity.CpMessage;
import com.pixelai.api.component.dao.CpMessageMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.utils.StringUtil;
import org.springframework.stereotype.Service;
import com.pixelai.api.component.service.CpMessageService;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2024-10-27
 */
@Service
public class CpMessageServiceImpl extends ServiceImpl<CpMessageMapper, CpMessage> implements CpMessageService {

    @Override
    public List<CpMessage> list(CpMessage example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<CpMessage> page(CpMessage example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<CpMessage> buildWrapper(CpMessage example) {
        QueryWrapper<CpMessage> wrapper     = new QueryWrapper<>();
        wrapper.lambda().eq(StringUtil.isNotBlank(example.getType()), CpMessage::getType,example.getType()).
                orderByDesc(CpMessage::getCreatetime);
        return wrapper;
    }

}
