package com.pixelai.api.group.dao;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.toolkit.Constants;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.group.entity.AcGroup;
import com.pixelai.api.group.vo.AcGroupVo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author mzl
 * @since 2020-07-09
 */
public interface AcGroupMapper extends BaseMapper<AcGroup> {

    /**
     * 条件查询
     *
     * @param queryWrapper
     * @return
     */
    List<AcGroupVo> findByExample(@Param(Constants.WRAPPER) QueryWrapper<AcGroupVo> queryWrapper);

    /**
     * 分页条件查询
     *
     * @param queryWrapper
     * @param page
     * @return
     */
    List<AcGroupVo> findByExample(@Param(Constants.WRAPPER) QueryWrapper<AcGroupVo> queryWrapper, Page page);

    /**
     * 根据角色编码获取角色订单
     *
     * @param acgroup
     * @return
     */
    AcGroup findByAcgroup(@Param("acgroup") final String acgroup);

}
