package com.pixelai.api.group.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.group.entity.AcActionPage;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author mzl
 * @since 2021-01-25
 */
public interface AcActionPageService extends IService<AcActionPage> {

    /**
     * 条件查询
     *
     * @param example
     * @return
     */
    List<AcActionPage> list(AcActionPage example);

    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    IPage<AcActionPage> page(AcActionPage example, IPage page);

    /**
     * 获取角色的可访问页面
     *
     * @param groupid
     * @return
     */
    List<String> findByGroupid(Integer groupid);

    /**
     * 批量获取功能页面
     *
     * @param actions
     * @return
     */
    List<AcActionPage> findByActions(List<String> actions);

}
