package com.pixelai.api.group.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.group.entity.AcAction;
import com.pixelai.api.group.vo.AcActionVo;

import java.util.List;

/**
 * <p>
 * 服务类
 * </p>
 *
 * @author mzl
 * @since 2020-07-09
 */
public interface AcActionService extends IService<AcAction> {

    /**
     * 条件查询
     *
     * @param example
     * @return
     */
    List<AcActionVo> findByExample(AcActionVo example);

    /**
     * 分页查询
     *
     * @param example
     * @param page
     * @return
     */
    Page<AcActionVo> findByPage(AcActionVo example, Page page);

    /**
     * 根据角色类型id获取模块列表
     *
     * @param moduleid
     * @return
     */
    List<AcAction> findByModuleid(Integer moduleid);

    /**
     * 根据编码获取功能
     *
     * @param acAction
     * @return
     */
    AcAction findByAcAction(String acAction);

}
