package com.pixelai.api.pa.controller;

import com.pixelai.api.pa.entity.PaCreationRelease;
import com.pixelai.api.user.service.AcUserService;
import org.springframework.web.bind.annotation.RequestMapping;
import com.base.annotation.SysLog;
import org.springframework.web.bind.annotation.RestController;
import com.base.helper.BaseController;
import com.base.helper.Result;
import com.pixelai.api.pa.entity.PaVipCurrency;
import com.pixelai.api.pa.service.PaVipCurrencyService;
import io.swagger.annotations.*;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.dao.DataIntegrityViolationException;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;

import javax.validation.Valid;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author gjj
 * @since 2024-12-04
 */
@Api(tags = "用户余额")
@RestController
@RequestMapping("/paVipCurrency")
public class PaVipCurrencyController extends BaseController {

    private static final Logger       LOG = LoggerFactory.getLogger(PaVipCurrencyController.class);
    @Autowired
    private              PaVipCurrencyService entityService;
    @Autowired
    private AcUserService acUserService;

    @SysLog(action = "checkAccount", value = "查询个人账户信息")
    @ApiOperation(value = "查询个人账户信息",notes = "查询个人账户信息")
    @RequestMapping(value="",method = {RequestMethod.GET})
    public Result<String> checkAccount(){
        Integer userId=acUserService.getUserId();
        PaVipCurrency paVipCurrency=entityService.lambdaQuery()
                .eq(PaVipCurrency::getUserid,userId)
                .eq(PaVipCurrency::getState,"t").one();
        return new Result(true, paVipCurrency);
    }

//    @SysLog(action = "findByPage", value = "分页查询用户余额")
//    @ApiOperation(value = "分页查询用户余额", notes = "分页查询用户余额")
//    @RequestMapping(method = RequestMethod.GET)
//    @ApiImplicitParams({@ApiImplicitParam(name = "size", value = "分页大小", paramType = "query"),
//            @ApiImplicitParam(name = "current", value = "当前页面：从1开始", paramType = "query")})
//    public Result<IPage<PaVipCurrency>> findByPage(final PaVipCurrency example, final Page page) {
//        IPage<PaVipCurrency>        records    = entityService.page(example,page);
//        return new Result(true, records);
//    }
//
//    @SysLog(action = "delete", value = "删除用户余额")
//    @ApiOperation(value = "删除用户余额")
//    @RequestMapping(value = "{id}", method = {RequestMethod.DELETE})
//    @ApiImplicitParam(name = "id", value = "用户余额ID", required = true, paramType = "path")
//    public Result delete(@PathVariable final Integer id) {
//        try {
//            entityService.removeById(id);
//            return new Result(true, "成功删除用户余额", null);
//        } catch (DataIntegrityViolationException e) {
//            LOG.error("删除用户余额失败", e);
//            return new Result(false, "删除用户余额失败", "该用户余额不能删除，存在其他关联数据");
//        } catch (Exception e) {
//            LOG.error("删除用户余额失败", e);
//            return new Result(false, "删除用户余额失败", e.getMessage());
//        }
//    }
//
//    @SysLog(action = "one", value = "查询单个用户余额")
//    @ApiOperation(value = "查询单个用户余额")
//    @RequestMapping(value = "{id}", method = {RequestMethod.GET})
//    @ApiImplicitParam(name = "id", value = "用户余额ID", required = true, paramType = "path")
//    public Result one(@PathVariable final Integer id) {
//        try {
//            PaVipCurrency entity = entityService.getById(id);
//            return new Result(true, entity);
//        } catch (Exception e) {
//            LOG.error("查询单个用户余额失败", e);
//            return new Result(false, new PaVipCurrency());
//        }
//    }
//
//    @SysLog(action = "add", value = "添加用户余额")
//    @ApiOperation(value = "添加用户余额")
//    @RequestMapping(method = {RequestMethod.POST})
//    public Result add(@Valid @RequestBody final PaVipCurrency entity, final BindingResult result) {
//        try {
//            if (result.hasErrors()) {
//                Map<String, String> map      = this.getErrors(result);
//                String              errorMsg = map.entrySet().iterator().next().getValue();
//                return new Result(false, "保存用户余额失败", errorMsg, map);
//            } else {
//                entityService.save(entity);
//                return new Result(true, "成功保存用户余额", null);
//            }
//        } catch (Exception e) {
//            LOG.error("添加用户余额失败", e);
//            return new Result(false, "保存用户余额失败", e.getMessage());
//        }
//    }
//
//    @SysLog(action = "update", value = "修改用户余额")
//    @ApiOperation(value = "修改用户余额")
//    @RequestMapping(method = {RequestMethod.PUT})
//    public Result update(@Valid @RequestBody final PaVipCurrency entity, final BindingResult result) {
//        try {
//            if (result.hasErrors()) {
//                Map<String, String> map      = this.getErrors(result);
//                String              errorMsg = map.entrySet().iterator().next().getValue();
//                return new Result(false, "修改用户余额失败", errorMsg, map);
//            } else {
//                if (null == entity.getId()) {
//                    throw new RuntimeException("id不能为空");
//                }
//                entityService.updateById(entity);
//                return new Result(true, "成功修改用户余额", null);
//            }
//        } catch (Exception e) {
//            LOG.error("修改用户余额失败", e);
//            return new Result(false, "修改用户余额失败", e.getMessage());
//        }
//    }
//
//    @ApiOperation(value = "全部用户余额")
//    @RequestMapping(value = "all", method = RequestMethod.GET)
//    public Result<List<PaVipCurrency>> all(PaVipCurrency example) {
//        List<PaVipCurrency> entitys = entityService.list(example);
//        if (null != entitys) {
//            return new Result<>(true, entitys);
//        }
//        return new Result<>(true, Collections.emptyList());
//    }

}
