package com.pixelai.api.pa.entity;

import com.baomidou.mybatisplus.annotation.IdType;

import java.math.BigDecimal;
import java.time.LocalDateTime;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import java.io.Serializable;
import java.util.Date;

import com.pixelai.api.pa.entity.enums.PayState;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 * 
 * </p>
 *
 * @author gjj
 * @since 2025-01-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="PaOrder", description="")
public class PaOrder implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    @ApiModelProperty(value = "用户 ID")
    private Integer memberId;

    @ApiModelProperty(value = "订单号")
    private String orderNum;

    @ApiModelProperty(value = "支付人账号")
    private String memberAccount;

    @ApiModelProperty(value = "商家账号")
    private String merchantAccount;

    @ApiModelProperty(value = "支付金额")
    private BigDecimal amount;

    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "支付用途")
    private String orderType;

    @ApiModelProperty(value = "支付状态")
    private PayState payStatus;

    @ApiModelProperty(value = "支付结果")
    private String result;

    @ApiModelProperty(value = "状态(有效:t 无效:f)")
    private String state;

    @ApiModelProperty(value = "1-5, 2-10, 3-20, 4-30, 5-50, 6-100")
    private String buyType;

    @TableField(exist = false)
    @ApiModelProperty(value = "预下单地址")
    private String h5Url;

    @TableField(exist = false)
    @ApiModelProperty(value = "openid")
    private String openid;
}
