package com.pixelai.api.pa.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.pixelai.api.pa.entity.PaPictureWall;
import com.pixelai.api.pa.entity.PaServices;
import com.pixelai.api.pa.entity.PaVipCurrency;
import com.baomidou.mybatisplus.extension.service.IService;
import com.pixelai.api.user.entity.AcUser;

import java.util.List;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author gjj
 * @since 2024-12-04
 */
public interface PaVipCurrencyService extends IService<PaVipCurrency> {
    /**
     * 当前用户购买原图扣除钻石
     * @return
     */
    Boolean consumeOriginalPicture(Integer userId, PaPictureWall paPictureWall);
    /**
     * 当前用户使用AI接口扣除钻石
     * @return
     */
    Boolean consume(Integer userId, PaServices paServices);

    /**
     * 条件查询
     * @param example
     * @return
     */
    List<PaVipCurrency> list(PaVipCurrency example);

    /**
     * 分页查询
     * @param example
     * @param page
     * @return
     */
    IPage<PaVipCurrency> page(PaVipCurrency example,IPage page);

    /**
     * userId获取
     * @param memberId
     * @return
     */
    PaVipCurrency findByUserId(Integer memberId);
}
