package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.pa.entity.PaCollection;
import com.pixelai.api.pa.dao.PaCollectionMapper;
import com.pixelai.api.pa.service.PaCollectionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.pa.vo.PaCollectionVo;
import com.pixelai.api.pa.vo.PaCreationVo;
import com.pixelai.api.user.service.AcUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2024-12-05
 */
@Service
public class PaCollectionServiceImpl extends ServiceImpl<PaCollectionMapper, PaCollection> implements PaCollectionService {
    @Autowired
    private AcUserService acUserService;
    @Override
    public List<PaCollection> list(PaCollection example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaCollection> page(PaCollection example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    @Override
    public IPage<PaCollectionVo> findByPage(PaCollection example, Page page) {
        page.setOptimizeCountSql(false);
        return page.setRecords(this.baseMapper.findByExample(buildPaCollectionVoWrapper(example), page));
    }

    private QueryWrapper<PaCollectionVo> buildPaCollectionVoWrapper(PaCollection example) {
        Integer userId=acUserService.getUserId();
        QueryWrapper<PaCollectionVo> wrapper     = new QueryWrapper<>();
        wrapper.eq("user_id", userId)
                .eq("collection_state", "t")
                .eq("photo_state", "t")
                .eq("creation_state", "t")
                .orderByDesc("createtime");
        return wrapper;
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaCollection> buildWrapper(PaCollection example) {
        QueryWrapper<PaCollection> wrapper     = new QueryWrapper<>();
        return wrapper;
    }

}
