package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.pixelai.api.pa.entity.PaConsumption;
import com.pixelai.api.pa.dao.PaConsumptionMapper;
import com.pixelai.api.pa.service.PaConsumptionService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.user.entity.AcUser;
import com.pixelai.api.user.service.AcUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2024-12-04
 */
@Service
public class PaConsumptionServiceImpl extends ServiceImpl<PaConsumptionMapper, PaConsumption> implements PaConsumptionService {
    @Autowired
    private AcUserService acUserService;
    @Override
    public List<PaConsumption> list(PaConsumption example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaConsumption> page(PaConsumption example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaConsumption> buildWrapper(PaConsumption example) {
        QueryWrapper<PaConsumption> wrapper     = new QueryWrapper<>();
        Integer userId=acUserService.getUserId();
        AcUser acuser=acUserService.getById(userId);
        if (acuser.getAcgroup()!=1){
            wrapper.lambda().eq(PaConsumption::getUserid,userId);
        }
        wrapper.orderByDesc("createtime");
        return wrapper;
    }

}
