package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.pa.entity.PaCreation;
import com.pixelai.api.pa.dao.PaCreationMapper;
import com.pixelai.api.pa.service.PaCreationService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.pa.vo.PaCreationVo;
import com.pixelai.api.user.service.AcUserService;
import com.pixelai.utils.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2024-12-05
 */
@Service
public class PaCreationServiceImpl extends ServiceImpl<PaCreationMapper, PaCreation> implements PaCreationService {
    @Autowired
    private AcUserService acUserService;
    @Override
    public List<PaCreation> list(PaCreation example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaCreation> page(PaCreation example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    public Page<PaCreationVo> findByPage(PaCreationVo example, Page page) {
        page.setOptimizeCountSql(false);
        return page.setRecords(this.baseMapper.findByExample(buildPaCreationVoWrapper(example), page));
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaCreation> buildWrapper(PaCreation example) {
        QueryWrapper<PaCreation> wrapper     = new QueryWrapper<>();
        return wrapper;
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaCreationVo> buildPaCreationVoWrapper(PaCreationVo example) {
        Integer userId=acUserService.getUserId();
        QueryWrapper<PaCreationVo> wrapper     = new QueryWrapper<>();
        wrapper.eq("user_id", userId)
                .eq("photo_state", "t")
                .eq(example.getReviewStatus()!=null,"review_status", example.getReviewStatus())
                .in("creation_state","t","create","fail")
                .orderByDesc("createtime");
        return wrapper;
    }

}
