package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.pa.dao.PaOrderMapper;
import com.pixelai.api.pa.entity.PaOrder;
import com.pixelai.api.pa.service.PaOrderService;
import com.pixelai.config.WeChatConfig;
import com.pixelai.utils.WeChatUtil;
import com.wechat.pay.java.core.exception.MalformedMessageException;
import com.wechat.pay.java.service.payments.h5.H5Service;
import com.wechat.pay.java.service.payments.h5.model.*;
import eu.bitwalker.useragentutils.UserAgent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2025-01-19
 */
@Service
public class PaOrderServiceImpl extends ServiceImpl<PaOrderMapper, PaOrder> implements PaOrderService {


    @Override
    public List<PaOrder> list(PaOrder example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaOrder> page(PaOrder example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    @Override
    public PaOrder getOrderByTradeNo(String outTradeNo) {
        QueryWrapper<PaOrder> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("order_num", outTradeNo);
        queryWrapper.eq("state", "t");
        return this.getOne(queryWrapper);
    }


    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaOrder> buildWrapper(PaOrder example) {
        QueryWrapper<PaOrder> wrapper     = new QueryWrapper<>();
        wrapper.lambda()
                .eq(example.getMemberId() != null, PaOrder::getMemberId, example.getMemberId());
        return wrapper;
    }

}
