package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.pixelai.api.component.vo.CpPhotoVo;
import com.pixelai.api.pa.entity.PaPictureWall;
import com.pixelai.api.pa.dao.PaPictureWallMapper;
import com.pixelai.api.pa.service.PaPictureWallService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.pa.vo.PaPictureWallVo;
import com.pixelai.utils.StringUtil;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2025-01-16
 */
@Service
public class PaPictureWallServiceImpl extends ServiceImpl<PaPictureWallMapper, PaPictureWall> implements PaPictureWallService {

    @Override
    public List<PaPictureWall> list(PaPictureWall example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaPictureWall> page(PaPictureWall example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    @Override
    public IPage<PaPictureWallVo> findByPage(PaPictureWallVo example, Page page) {
        page.setOptimizeCountSql(false);
        return page.setRecords(this.baseMapper.findByExample(buildPaPictureWallVoWrapper(example), page));

    }

    private  QueryWrapper<PaPictureWallVo> buildPaPictureWallVoWrapper(PaPictureWallVo example) {
        QueryWrapper<PaPictureWallVo> wrapper     = new QueryWrapper<>();
        wrapper.like(StringUtil.isNotBlank(example.getName()),"name",example.getName())
                .like(StringUtil.isNotBlank(example.getLabelName()),"label_name",example.getLabelName())
                .like(StringUtil.isNotBlank(example.getServiceName()),"service_name",example.getServiceName())
                .eq(example.getId()!=null,"id",example.getId())
                .eq("state","t")
                .orderByDesc("createtime");
        return wrapper;
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaPictureWall> buildWrapper(PaPictureWall example) {
        QueryWrapper<PaPictureWall> wrapper     = new QueryWrapper<>();
        return wrapper;
    }

}
