package com.pixelai.api.pa.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.base.context.Context;
import com.base.context.ContextHolder;
import com.pixelai.api.pa.entity.PaConsumption;
import com.pixelai.api.pa.entity.PaPictureWall;
import com.pixelai.api.pa.entity.PaServices;
import com.pixelai.api.pa.entity.PaVipCurrency;
import com.pixelai.api.pa.dao.PaVipCurrencyMapper;
import com.pixelai.api.pa.service.PaConsumptionService;
import com.pixelai.api.pa.service.PaVipCurrencyService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.pixelai.api.user.entity.AcUser;
import com.pixelai.api.user.service.AcUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author gjj
 * @since 2024-12-04
 */
@Service
public class PaVipCurrencyServiceImpl extends ServiceImpl<PaVipCurrencyMapper, PaVipCurrency> implements PaVipCurrencyService {
    @Autowired
    private PaConsumptionService paConsumptionService;
    @Autowired
    private AcUserService acUserService;
    @Override
    public Boolean consume(Integer userId, PaServices paServices) {
        PaVipCurrency paVipCurrency=this.lambdaQuery().eq(PaVipCurrency::getUserid,userId)
                .eq(PaVipCurrency::getState,"t").one();
        //余额不足
        Integer balance=paVipCurrency.getNumerical();
        if ( balance< paServices.getPrice()){
            return  false;
        }
        //消费
        paVipCurrency.setNumerical(balance-paServices.getPrice());
        this.updateById(paVipCurrency);
        PaConsumption paConsumption=new PaConsumption(acUserService.getUserId(),"sub",paServices.getPrice(),paServices.getId(),"AI能力消费",paServices.consume());
        paConsumptionService.save(paConsumption);
        return true;
    }

    public Boolean consumeOriginalPicture(Integer userId, PaPictureWall paPictureWall) {
        PaVipCurrency paVipCurrency=this.lambdaQuery().eq(PaVipCurrency::getUserid,userId)
                .eq(PaVipCurrency::getState,"t").one();
        //余额不足
        Integer balance=paVipCurrency.getNumerical();
        if ( balance< paPictureWall.getPrice()){
            return  false;
        }
        //消费
        paVipCurrency.setNumerical(balance-paPictureWall.getPrice());
        this.updateById(paVipCurrency);
        PaConsumption paConsumption=new PaConsumption(acUserService.getUserId(),"sub",paPictureWall.getPrice(),"购买原图消费",paPictureWall.consume());
        paConsumptionService.save(paConsumption);
        return true;
    }

    @Override
    public List<PaVipCurrency> list(PaVipCurrency example) {
        return this.list(buildWrapper(example));
    }

    @Override
    public IPage<PaVipCurrency> page(PaVipCurrency example, IPage page) {
        return this.page(page,buildWrapper(example));
    }

    @Override
    public PaVipCurrency findByUserId(Integer memberId) {
        QueryWrapper<PaVipCurrency> queryWrapper=new QueryWrapper<>();
        queryWrapper.lambda()
                .eq(PaVipCurrency::getUserid,memberId)
                .eq(PaVipCurrency::getState,"t");
        return getOne(queryWrapper);
    }

    /**
     * 构建查询
     *
     * @param example
     * @return
     */
    private QueryWrapper<PaVipCurrency> buildWrapper(PaVipCurrency example) {
        QueryWrapper<PaVipCurrency> wrapper     = new QueryWrapper<>();
        return wrapper;
    }

}
