package com.pixelai.api.user.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.base.context.Context;
import com.base.context.ContextHolder;
import com.base.helper.Result;
import com.base.helper.StringUtils;
import com.pixelai.api.group.entity.AcGroup;
import com.pixelai.api.group.service.AcActionPageService;
import com.pixelai.api.group.service.AcGroupService;
import com.pixelai.api.pa.entity.PaVipCurrency;
import com.pixelai.api.pa.entity.PaVipLevel;
import com.pixelai.api.pa.service.PaVipCurrencyService;
import com.pixelai.api.pa.service.PaVipLevelService;
import com.pixelai.api.user.entity.MbMember;
import com.pixelai.api.user.service.AcLoginlogService;
import com.pixelai.api.user.service.MbMemberService;
import com.pixelai.api.user.dao.AcUserMapper;
import com.pixelai.api.user.entity.AcUser;
import com.pixelai.api.user.service.AcUserService;
import com.pixelai.api.user.vo.*;
import com.pixelai.config.UserConfig;
import com.pixelai.utils.PasswordUtil;
import com.pixelai.utils.WxLoginUtil;
import com.pixelai.utils.oConvertUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 服务实现类
 * </p>
 *
 * @author mzl
 * @since 2020-07-09
 */
@Service
public class AcUserServiceImpl extends ServiceImpl<AcUserMapper, AcUser> implements AcUserService {
    @Autowired
    private AcUserMapper acUserMapper;
    @Autowired
    private MbMemberService mbMemberService;
    @Autowired
    private PaVipLevelService paVipLevelService;
    @Autowired
    private PaVipCurrencyService paVipCurrencyService;
    @Autowired
    private AcGroupService acGroupService;
    @Autowired
    private AcActionPageService acActionPageService;
    @Autowired
    private AcLoginlogService acLoginlogService;

    @Override
    public Integer getUserId() {
        Context context = ContextHolder.currentContext();
        Integer userId=context.currentUser().getId();
       //如果无法获取，则默认一个用户，测试专用，正式环境必须屏蔽
        if (context.currentToken().equals("fbc545a91cc94fe89296828a25a7e08e@9085553879028596738")){
            userId=96;
        }
        return userId;
    }
    @Override
    public Result<LoginSuccessVo> phoneLogin(String username, String password) {
        AcUser user = this.findByUsername(username,2);
        if(user==null){
            return new Result<>(false,"用户不存在","");
        }
        if(user!=null && user.getUsertype()!=2){
            return new Result<>(false,"用户不存在","");
        }
        String passwordEncode = PasswordUtil.encrypt(password, "pixelai", user.getSalt());
        if(!passwordEncode.equals(user.getPassword())){
            return new Result<>(false,"密码错误","");
        }
        //      5.登录成功设置令牌
//        Context context = ContextHolder.currentContext();
//        return new Result<>(true,new LoginSuccessVo(acUservo, context.currentToken()));
        acLoginlogService.addLog(user.getId(), user.getUsername(), "t", null);
        Context context = ContextHolder.currentContext();
        return new Result<>(true, normalizeContext(context, user));

    }
//    @Override
//    public Result<LoginSuccessVo> phoneLogin(String username, String password) {
//        AcUserVo acUservo=acUserMapper.getMemberByAccount(username);
//        if(acUservo==null){
//            return new Result<>(false,"用户不存在","");
//        }
//        if(acUservo!=null && acUservo.getUsertype()!=2){
//            return new Result<>(false,"用户不存在","");
//        }
//        String passwordEncode = PasswordUtil.encrypt(password, "pixelai", acUservo.getSalt());
//        if(!passwordEncode.equals(acUservo.getPassword())){
//            return new Result<>(false,"密码错误","");
//        }
//        //      5.登录成功设置令牌
////        Context context = ContextHolder.currentContext();
////        return new Result<>(true,new LoginSuccessVo(acUservo, context.currentToken()));
//        acLoginlogService.addLog(acUservo.getId(), acUservo.getUsername(), "t", null);
//        Context context = ContextHolder.currentContext();
//        return new Result<>(true, normalizeContext(context, acUservo));
//
//    }

    private LoginSuccessVo normalizeContext(Context context, AcUser user) {
        AcGroup acGroup = acGroupService.getById(user.getAcgroup());
        AcUserVo vo      = new AcUserVo(user, acGroup.getGrouptypeid() + "", acGroup.getAcgroup());
        Context  ctx     = ContextHolder.isOnline(vo, AcUserVo.class);
        if (null != ctx && !StringUtils.isEquals(ctx.currentToken(), context.currentToken())) {
            ContextHolder.remove(ctx.currentToken());
        }
        context.asUser(vo);
        List<String> accessUris = acActionPageService.findByGroupid(acGroup.getId());
        if (null != accessUris && accessUris.size() > 0) {
            context.asAccessUris(accessUris);
        }
        user.setPassword(null);
        return new LoginSuccessVo(user, context.currentToken());
    }

    @Override
    public Result<String> phoneRegister(String username, String password, String confirmPassword) {
        if(!password.equals(confirmPassword)){
            return new Result<>(false,"两次输入的密码不一致");
        }
        AcUser acUser=acUserMapper.findByUsername(username,2);
        if(acUser!=null){
            return new Result<>(false,"用户已存在，无法注册");
        }
        String salt = oConvertUtils.randomGen(8);
        String passwordEncode = PasswordUtil.encrypt(password, "pixelai", salt);
        //保存账户信息
        AcUser user=new AcUser();
        user.setUsername(username);
        user.setRealname("用户"+username);
        user.setSalt(salt);
        user.setPassword(passwordEncode);
        user.setEnable("1");
        user.setAcgroup(2);
        user.setUsertype(2);
        user.setState("t");
        user.setCreatetime(new Date());
        user.setThirdType("用户");
        this.save(user);
        //保存用户基本信息
        MbMember mbMember=new MbMember();
        mbMember.setUserid(user.getId());
        mbMember.setPhone(username);
        mbMember.setRegisterTime(new Date());
        mbMember.setLoginTime(new Date());
        mbMember.setNickName("用户" + username);
        mbMemberService.save(mbMember);
        //开通默认会员
        PaVipLevel paVipLevel=new PaVipLevel();
        paVipLevel.setUserid(user.getId());
        paVipLevel.setName("VIP1");
        paVipLevel.setLevel("1");
        paVipLevel.setExperience(0);
        paVipLevel.setState("t");
        paVipLevelService.save(paVipLevel);
        //默认分配0钻石
        PaVipCurrency paVipCurrency=new PaVipCurrency();
        paVipCurrency.setUserid(user.getId());
        paVipCurrency.setNumerical(0);//默认分配0钻石
        paVipCurrency.setState("t");
        paVipCurrencyService.save(paVipCurrency);
        return new Result<>(true,"注册成功");
    }

    @Override
    public Result<LoginSuccessVo> wxLogin(String userCode, String phoneCode) {
        //1.获取openid
        String openId = WxLoginUtil.getOpenid(userCode);
        //2.获取手机号资格凭证
        String phoneToken = WxLoginUtil.getAccessToken();
        //3.获取手机号
        String phone = WxLoginUtil.getPhone(phoneCode, phoneToken);
        if(com.aliyun.core.utils.StringUtils.isBlank(openId) || com.aliyun.core.utils.StringUtils.isBlank(phoneToken) || com.aliyun.core.utils.StringUtils.isBlank(phone)){
            return new Result(false, new AcUserVo());
        }
        //测试数据
//        String openId="2";
//        String phone="19854796024";
        //4.根据openid查询数据库  如果有的话就修改手机号， 没有就新增
        AcUserVo acUserVo ;
        try {
            acUserVo=acUserMapper.getMemberByThirdId("微信用户",openId);
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        //查无此人时新增
        if (acUserVo==null) {
            String salt = oConvertUtils.randomGen(8);
            String passwordEncode = PasswordUtil.encrypt(phone, "123456", salt);
            AcUser user=new AcUser();
            user.setUsername(phone);
            user.setSalt(salt);
            user.setPassword(passwordEncode);
            user.setEnable("1");
            user.setAcgroup(1);
            user.setUsertype(2);
            user.setState("t");
            user.setCreatetime(new Date());
            user.setThirdId(openId);
            user.setThirdType("微信用户");
            this.save(user);
            MbMember mbMember=new MbMember();
            mbMember.setUserid(user.getId());
            mbMember.setPhone(phone);
            mbMember.setRegisterTime(new Date());
            mbMember.setLoginTime(new Date());
            mbMember.setNickName("微信用户" + phone);
            mbMemberService.save(mbMember);
            acUserVo=acUserMapper.getMemberByThirdId("微信用户",openId);
        }else{
            if(acUserVo.getEnable().equals("0") || acUserVo.getState().equals("f")){
                return new Result<>(false,null,"用户已被禁用");
            }
        }
        //      5.登录成功设置令牌
        Context context = ContextHolder.currentContext();
        return new Result<>(true,new LoginSuccessVo(acUserVo, context.currentToken()));
    }

    @Override
    public Page<AcUserVo> findByPage(Page<AcUserVo> page, AcUserVo example) {

        /** 不进行 count sql 优化，解决 MP 无法自动优化 SQL 问题 */
        page.setOptimizeCountSql(false);
        return page.setRecords(baseMapper.findByExample(buildWrapper(example), page));
    }

    @Override
    public List<AcUserVo> findByExample(AcUserVo example) {
        return baseMapper.findByExample(buildWrapper(example));
    }

    @Override
    public List<AcUserVo> findByGroupid(Integer groupid) {
        QueryWrapper<AcUserVo> wrapper = new QueryWrapper<>();
        wrapper.lambda().eq(AcUserVo::getAcgroup, groupid).eq(AcUserVo::getState, "1");
        return this.baseMapper.findByExample(wrapper);
    }

    private QueryWrapper<AcUserVo> buildWrapper(AcUserVo example) {
        QueryWrapper<AcUserVo> wrapper = new QueryWrapper<AcUserVo>();

        /** 条件查询 */
        Integer acgroup         = example.getAcgroup();
        String  acgroupName     = example.getAcgroupName();
        Integer usertype        = example.getUsertype();
        String  usertypeName    = example.getUsertypeName();
        String  username        = example.getUsername();
        String  enable          = example.getEnable();

        wrapper.lambda()
                .eq(null != acgroup, AcUserVo::getAcgroup, acgroup)
                .eq(null != usertype, AcUserVo::getUsertype, usertype)
                .like(StringUtils.isNotEmpty(username), AcUserVo::getUsername, username)
                .eq(StringUtils.isNotEmpty(enable), AcUserVo::getEnable, enable)
                .eq(AcUserVo::getState, "t")
                .orderByDesc(AcUserVo::getId);

        /** 外键不支持lambda */
        wrapper.like(StringUtils.isNotEmpty(acgroupName), "acgroup_name", acgroupName)
                .like(StringUtils.isNotEmpty(usertypeName), "usertype_name", usertypeName);

        //搜索订单姓名
        String realname = example.getRealname();
        if (StringUtils.isNotEmpty(realname)) {
            wrapper.and(w -> w.like("realname", realname));
        }
        return wrapper;
    }

    @Override
    public AcUser findByUsername(String username,Integer usertype) {
        return this.baseMapper.findByUsername(username,usertype);
    }

    @Override
    public AcUser setEnable(Integer id, String enable) {
        AcUser acUser = this.getById(id);
        if (null == acUser || "0".equals(acUser.getState())) {
            throw new RuntimeException("没有找到id对应对象");
        }
        if (enable.equals(acUser.getEnable())) {
            throw new RuntimeException("该订单已经处于该状态");
        }
        acUser.setEnable(enable);
        this.updateById(acUser);
        return acUser;
    }

    @Override
    public AcUser registerExamineeUser(RegisterExamineeVo examinee) {
        AcUser acUser = new AcUser();
        acUser.setUsername(examinee.getUsername());
        acUser.setRealname(examinee.getRealname());
        acUser.setPassword(examinee.getIdentitynum().substring(examinee.getIdentitynum().length() - 6));
        acUser.setAcgroup(examinee.getAcgroup());
        acUser.setUsertype(examinee.getUsertype());
        acUser.setEnable("1");
        acUser.setCreatetime(new Date());
        acUser.setPwdupdatetime(new Date());
        acUser.setState("1");
        if (this.save(acUser)) {
            return this.findByUsername(examinee.getUsername(),2);
        } else {
            return null;
        }
    }

    @Override
    public AcUser registerStudentUser(RegisterStudentVo student) {
        AcUser acUser = new AcUser();
        acUser.setUsername(student.getUsername());
        acUser.setRealname(student.getName());
        acUser.setPassword(student.getExamineenum().substring(student.getExamineenum().length() - 6));
        acUser.setAcgroup(student.getAcgroup());
        acUser.setUsertype(student.getUsertype());
        acUser.setEnable("1");
        acUser.setCreatetime(new Date());
        acUser.setPwdupdatetime(new Date());
        acUser.setState("1");
        if (this.save(acUser)) {
            return this.findByUsername(student.getUsername(),2);
        } else {
            return null;
        }
    }

    @Override
    public AcUser updateUserRealname(Integer id, String realname) {
        AcUser acUser = this.getById(id);
        if (null != acUser && "1".equals(acUser.getState())) {
            acUser.setRealname(realname);
            this.updateById(acUser);
            return acUser;
        }
        return null;
    }

    @Override
    public AcUser setPwd(EnSetPwdVo setPwd) {
        AcUser acUser = this.baseMapper.findByResettoken(setPwd.getToken());
        if (null == acUser || "0".equals(acUser.getState())) {
            throw new RuntimeException("没有找到对应考生");
        }
        acUser.setPassword(setPwd.getPwd());
        super.updateById(acUser);
        return acUser;
    }

    @Override
    public List<AcUser> deleteByUserIds(List<Integer> userIds) {
        QueryWrapper<AcUser> wrapper = new QueryWrapper<>();
        wrapper.lambda().in(AcUser::getId, userIds);
        List<AcUser> list = super.list(wrapper);
        this.removeByIds(userIds);
        return list;
    }

    @Override
    public List<AcUser> selectByAcGroupAndDepartmentId(Integer acGroup, Integer departmentId) {
        return this.baseMapper.selectByAcGroupAndDepartmentId(acGroup,departmentId);
    }


}
